
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Facebook AI实验室开源相似性搜索库Faiss：性能高于理论峰值55%，提速8.5倍 / iVAN</title>

    <meta name="description" content="Facebook AI实验室开源相似性搜索库Faiss：性能高于理论峰值55%，提速8.5倍 在用户日常搜索过程中,一个经常出现的问题即大多数返回的网站结果拥有完全相同或者几乎一样的信息.而应用了相似性搜索的相似引擎即可为用户返回最恰当.最合适的结果,同时隐藏或者丢弃那些重复的数据. 但是,目前相似性搜索领域需要克服的难题即它的规模和运行速度.雷锋网近日了解到,Facebook的人工智能研究团队就称已在该问题上取得了重要进展.Facebook在新发布的论文&lt;Billion-scale similarity search with GPUs&gt;中表示,可在GPU 上实现十亿规模级 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Facebook AI实验室开源相似性搜索库Faiss：性能高于理论峰值55%，提速8.5倍</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3N0YXRpYy5sZWlwaG9uZS5jb20vdXBsb2Fkcy9uZXcvYXJ0aWNsZS83NDBfNzQwLzIwMTcwMy81OGI5MzkxM2FmYzhlLnBuZz9pbWFnZU1vZ3IyL2Zvcm1hdC9qcGcvcXVhbGl0eS85MA==.jpg"></p>
<p>在用户日常搜索过程中，一个经常出现的问题即大多数返回的网站结果拥有完全相同或者几乎一样的信息。而应用了相似性搜索的相似引擎即可为用户返回最恰当、最合适的结果，同时隐藏或者丢弃那些重复的数据。</p>
<p>但是，目前相似性搜索领域需要克服的难题即它的规模和运行速度。雷锋网近日了解到，Facebook的人工智能研究团队就称已在该问题上取得了重要进展。Facebook在新发布的论文《Billion-scale<br />
 similarity search with GPUs》中表示，可在GPU 上实现十亿规模级的相似性搜索，并且已开源该方法。</p>
<p>在处理图像或视频等复杂数据时会涉及专用数据库系统，而相似性搜索（similarity search）则可以在专用数据库系统中找寻应用。但问题是，这些复杂数据通常用高维特征表示，而且需要特定的索引结构。</p>
<p>因此，Facebook的研究人员就通过更好地利用 GPU的优势解决了这个问题 。尽管 GPU 擅长数据并行任务，但之前的方法要么会在并行性不高的算法（如 k-min selection）上遭遇瓶颈，要么不能有效利用内存的层次结构。</p>
<p>为此雷锋网了解到，他们提出一种可用于k-selection的新设计，使其能以高达性能理论峰值55%<br />
 的速度进行运算，并实现了比之前最佳的 GPU 方法快 8.5 倍的最近邻搜索。他们为以积量化（product<br />
quantization）为基础的暴力计算、近似和压缩域搜索提出优化设计，从而将其应用到不同的相似性搜索场景中。在所有这些场景中，该方法比之前的方法的最佳表现还要好，它可在<br />
 35 分钟内从 Yfcc100M 数据集的 9500 万张图像上构建一个高准确度的 k-NN 图，也可以在 12 个小时内在 4 个<br />
Maxwell Titan X GPU 上构建一个连接了 10 亿个向量的图。</p>
<p>现在Facebook已将该方法（Faiss）开源，使大家能进行比较和重复利用。</p>
<p><strong>概括的说，该论文的主要突破有：</strong></p>
<blockquote><ul>
<li>给出一个可在GPU上运行的k-selection算法。它可在快速寄存奇储器中运行，并且其灵活性能使它能与其他内核一起使用。对此我们给出了复杂性分析；</li>
<li>在GPU上实现的为精确和近似的k最近邻搜索的近最优算法布局;</li>
<li>通过一系列实验表明，在单一或多GPU配置中运行的中到大规模的最近邻搜索任务上，我们的方法大幅度优于先前技术。</li>
</ul>
</blockquote>
<p><strong><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3N0YXRpYy5sZWlwaG9uZS5jb20vdXBsb2Fkcy9uZXcvYXJ0aWNsZS83NDBfNzQwLzIwMTcwMy81OGI5MzkyMGE5ZmJhLnBuZz9pbWFnZU1vZ3IyL2Zvcm1hdC9qcGcvcXVhbGl0eS85MA==.jpg"></strong></p>
<p>图片选自论文（图片6）：从 Yfcc100M 数据集的 9500 万张图像上构建的高准确度 k-NN 图。第一张和最后一张图片为给定图片，算法通过计算得出两张图片之间最“和谐”的演变路径。</p>
<p><strong>开源库Faiss简介</strong></p>
<p>Faiss<br />
 是用于有效的相似性搜索（similarity search）和稠密矢量聚类（clustering of dense<br />
vectors）的库。它包含了可在任何大小向量集合里进行搜索的算法，向量集合的大小甚至可达到RAM容纳不下的地步。另外，它还包含了用于评估和参数调优的支持代码。Faiss<br />
 用 C ++编写，有 Python / numpy 的完整包装。其中最有用的一些算法则在 GPU 上实现。</p>
<p>Faiss<br />
包含几种相似性搜索的方法。它假定示例可以被表示为向量，并可以通过整数识别。除此之外，这些向量可以与 L2<br />
位距或点积进行比较。与一个查询向量（query vector）相似的向量是具有最低 L2 位距或最高点积的查询向量。Faiss<br />
还支持余弦相似性（cosine similarity），因为它属于标准化向量上的点积。</p>
<p>大多数方法，例如基于二元向量和紧凑量化代码的方法，仅使用向量的压缩表征，并不需要保留原始向量。这通常会降低搜索的准确性，但这些方法可在单个服务器上的主存储器中扩展到数十亿个向量。</p>
<p>该<br />
 GPU 实现可接受来自 CPU 或 GPU 内存的输入。在一个带有 GPU 的服务器上，其 GPU 索引可以被用作其 CPU<br />
索引的插入替换（比如用 GpuIndexFlatL2 替代 IndexFlatL2），而且来自或发往 GPU 内存的副本可以被自动处理。</p>
<p><strong>Faiss的构建</strong></p>
<p>该库基本上通过 C++ 实现。它带有可选择的 GPU （该GPU通过CUDA支持）以及一个可选的 Python 接口。编译采用的是Makefile。详细信息可参见INSTALL：</p>
<p><a href="https://github.com/facebookresearch/faiss/blob/master/INSTALL" rel="external nofollow noreferrer">https://github.com/facebookresearch/faiss/blob/master/INSTALL</a></p>
<p><strong>Faiss的工作原理</strong></p>
<p>Faiss 是围绕存储一个向量集的索引类型（index type）构建的，并且索引类型提供了一个利用 L2 和/或点积向量比较的函数，以使该函数能够在向量集中进行搜索。有些索引类型是简单的基线，如精确搜索。大多数可用的索引结构都对应以下几点权衡：</p>
<blockquote><ul>
<li>搜索时间</li>
<li>搜索质量</li>
<li>每个索引向量使用的内存大小</li>
<li>训练时间</li>
<li>无监督训练对外部数据的需求</li>
</ul>
</blockquote>
<p><strong>获取Faiss 完整版文档</strong></p>
<blockquote><ul>
<li>完整文档（包括一个指南）可以参阅 GitHub 的 wiki 页：</p>
<p>http://github.com/facebookresearch/faiss/wiki</li>
<li>doxygen 文档提供了每个类的信息：</li>
</ul>
<p>       <a href="http://rawgithub.com/facebookresearch/faiss/master/docs/html/annotated.html" rel="external nofollow noreferrer">http://rawgithub.com/facebookresearch/faiss/master/docs/html/annotated.html</a></p>
<ul>
<li>重现本研究论文的结果，可以参考基准 README</li>
</ul>
<p>       <a href="https://github.com/facebookresearch/faiss/blob/master/benchs/README.md" rel="external nofollow noreferrer">https://github.com/facebookresearch/faiss/blob/master/benchs/README.md</a></p></blockquote>
<p><strong>相似性搜索延伸阅读</strong></p>
<p>对相似性搜索不甚了解的同学，可以参看以下由雷锋网(公众号：雷锋网)整理的相似性搜索的延伸阅读。</p>
<p><strong>相似性搜索的分类：</strong></p>
<p>最邻近搜索（nearest neighbor search）和范围查询（range queries）是相似搜索的重要子分类，研究人员已针对这两种分类开发出多种解决方案。</p>
<p>相似性搜索中存在的问题也是搜索复杂对象时的固有问题。复杂对象会导致大多数技术对大范围集合的抓取能力等问题。而在相似性搜索时，大部分情况下对象都是复杂的。</p>
<p><strong>相似性搜索的工作原理：</strong></p>
<p>相似性搜索工具可用于识别哪些候选要素与要匹配的一个或多个输入要素最相似（或最相异）。相似性的基础是数值属性（感兴趣属性）的指定列表。如果指定了一个以上的要匹配的输入要素，相似性将基于每个感兴趣属性的平均值。输出要素类（输出要素）将包含要匹配的输入要素以及找到的所有匹配的候选要素，这些要素以相似程度排序（由最相似或最不相似参数指定）。返回的匹配数基于结果数参数的值。</p>
<p><strong>相似性搜索的应用</strong></p>
<p>相似性搜索在很多场景下都可以发挥它的优势，比如：</p>
<blockquote><ul>
<li>人力资源经理可能想要证明其公司薪资水平的合理性。找出在城市规模、生活成本和便利设施方面相似的城市后，她便可以查看这些城市的薪资水平，从而确定它们是否与本公司的薪资水平一致。</li>
<li>犯罪分析师希望搜索数据库以查看某罪行是否属于较重犯罪形式或有重罪趋势。</li>
<li>课外健身计划在 A 城极其成功。计划提倡者期望找到与其计划推广的候选城市具有相似特征的其他城市。</li>
<li>执法机构用此方法揭露毒品种植地或生产地。标识具有相似特征的地方可能有助于制定未来的搜索目标。</li>
<li>大型零售商不仅拥有数个成功店铺，也有少数业绩不佳的店铺。找到一些具有相似人口特征和环境特征（交通便利性、知名度以及商业互补性等等）的地方有助于标识新店的最佳位置。</li>
</ul>
</blockquote>
<p>本文作者：夏睿</p>
<p>本文转自雷锋网禁止二次转载，<a href="https://www.leiphone.com/news/201703/lzEITGcs5Miuh8k5.html" rel="external nofollow noreferrer">原文链接</a><strong><br /></strong></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 17:05:05</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd/" title="性能">性能</a>, <a href="https://www.iamivan.net/tag/%e7%b4%a2%e5%bc%95/" title="索引">索引</a>, <a href="https://www.iamivan.net/tag/gpu/" title="GPU">GPU</a>, <a href="https://www.iamivan.net/tag/%e7%ae%97%e6%b3%95/" title="算法">算法</a>, <a href="https://www.iamivan.net/tag/facebook/" title="Facebook">Facebook</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Facebook AI实验室开源相似性搜索库Faiss：性能高于理论峰值55%，提速8.5倍的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwxeKnb.html" rel="bookmark">从Facebook AI Research开源fastText谈起文本分类：词向量模性、深度表征和全连接</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				更多深度文章,请关注:https://yq.aliyun.com/cloud          文本分类(text classification)是机器学习的一个主要任务,通常用作垃圾邮件检测.新闻/文章主题生成.多义词正确词义选择等.之前,Statsbot团队已经分享了&lt;如何检测垃圾邮件/信息/用户评论&gt;.本文主要介绍少数几个广义上的文本分类算法及相关案例,同时也提供了一些有用的教程和工具. 文本分类基准(Benchmarks) 目前,搞文本挖掘的人通常会使用很多小技巧和工具,比如TF-ID			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQjWKQM.html" rel="bookmark">揭开Faiss的面纱 探究Facebook相似性搜索工具的原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Facebook 开源了 AI 相似性搜索工具 Faiss.而在一个月之后的今天,Facebook 发布了对 Faiss 的官方原理介绍. 它是一个能使开发者快速搜索相似多媒体文件的算法库.而该领域一直是传统的搜索引擎的短板.借助Faiss,Facebook 在十亿级数据集上创建的最邻近搜索(nearest neighbor search),比此前的最前沿技术快 8.5 倍,并创造出迄今为止学术圈所见最快的.运行于 GPU 的 k-selection 算法.Facebook 人工智能实验室(FA			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPPjrlp.html" rel="bookmark">Facebook AML实验室负责人：将AI技术落地的N种方法（上）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(Facebook AML实验室负责人 Joaquin Candela) 雷锋网(公众号:雷锋网)按:在Facebook,有两个实验室领导着AI发展方向,一个是Yann LeCun领导的FAIR实验室,偏向AI的基础研究:另一个,就是AML实验室,偏向机器学习应用,负责将AI技术落地在Facebook各种产品.本月初,AML实验室负责人Joaquin Candela在@Scale大会上发表了一次演讲,他讲述了Facebook在规模化应用AI技术的方方面面,包括Facebook人工智能母体FB L			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJA3Z2p.html" rel="bookmark">Facebook AML实验室负责人：将AI技术落地的N种方法（下）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				雷锋网按:本文为AML实验室负责人Joaquin Candela在@Scale大会上发表了的关于如何将AI技术应用于Facebook各个领域的下半部分演讲内容.此篇中,Joaquin Candela和大家讲解了AI技术在视频理解平台.文本理解.语音识别.视频风格变换多个领域的应用,并配以实际案例帮助大家理解.上篇内容及演讲视频请看雷锋网报道&lt;Facebook AML实验室负责人:将AI技术落地的N种方法(上)&gt;.以下为雷锋网编译. 图像视频理解:Lumos平台 Lumos的故事很有意思,它最初			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7kwZz.html" rel="bookmark">Facebook开源 PyTorch版 fairseq，准确性最高、速度比循环神经网络快9倍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今年5月,Facebook AI研究院(FAIR)发表了他们的研究成果fairseq,在fairseq中,他们使用了一种新型的卷积神经网络来做语言翻译,比循环神经网络的速度快了9倍,而且准确性也是现有模型中最高的.此外,他们在GitHub公布了fair序列建模工具包的源代码和训练好的系统,其他的研究者可以在此基础上建立自己的关于翻译.文本总结和其他任务的模型. 详情可参见快9倍!Facebook开源机器学习翻译项目fairseq一文. 日前,Facebook AI研究团队又在GitHub上开源了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvEnerb.html" rel="bookmark">【复盘DeepMind2017】国际最顶级AI实验室：战柯洁、打星际、巨亏背后</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				AlphaGo 回顾2017,不仅仅局限于DeepMind,AlphaGo也是不可跳过的关键词.在这一年,AlphaGo不仅没有沉寂,还完成了质的飞跃. AlphaGo Master/Ke Jie/Zero→AlphaZero 首先是2016年底至2017年年初,再度强化的AlphaGo以&quot;Master&quot;为名,在未公开其真实身份的情况下,借非正式的网络快棋对战进行测试,挑战中韩日台的一流高手,60战全胜 接着就是5月,被誉为&quot;世纪大战&quot;的乌镇围棋峰会上,AlphaG			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE6vGLM.html" rel="bookmark">Win10 UWP开发系列&mdash;&mdash;开源控件库：UWPCommunityToolkit</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:Win10 UWP开发系列--开源控件库:UWPCommunityToolkit 在开发应用的过程中,不可避免的会使用第三方类库.之前用过一个WinRTXamlToolkit.UWP,现在微软官方发布了一个新的开源控件库-- UWPCommunityToolkit 项目代码托管在Github上:https://github.com/Microsoft/UWPCommunityToolkit 包括以下几个类库: 都可以很方便的从Nuget上安装. NuGet Package Name des			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdyRx1z.html" rel="bookmark">DeepMind宣布在阿尔伯塔大学建立AI实验室，加拿大的AI研究又迎来强大推动力</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				日前,DeepMind宣布与阿尔伯塔大学联手,在加拿大埃德蒙顿建立国际化的AI研究实验室. 阿尔伯塔大学的计算科学教授和人工智能研究员Rich Sutton, Michael Bowling, Patrick Pilarski将会加入这个实验室,此外已知的成员还有Adam White以及2017年初发布DeepStack算法的六个研究员. (关于DeepStack算法雷锋网(公众号:雷锋网)此前已有详细介绍:CMU风头被抢,新型DeepStack算法抢先攻克德州扑克图灵测试) 上图从左至右:Ri			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zO2l43p.html" rel="bookmark">Facebook数据中心开源起因和哲学</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今年4月份,Facebook发布Open Compute Project,意在加速数据中心和服务器创新.但是,实施一个开源项目不只是发布数据那么简单.Facebook还需要获得其他社区成员的支持.除此之外,Facebook开源硬件团队还要更为严峻的挑战. Open Compute的始端 米迦勒此前曾效力于Google公司,他告诉VentureBeat,当他第一次来到Facebook时,&quot;我对服务器和数据中心非常了解&quot;.他不仅了解服务器网络架构,甚至可以作为数据中心维护人员亲自动手.在数			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6emob.html" rel="bookmark" class="title">Word公式编辑器常见问题的解决办法</a>
					<div>
						关于公式编辑器的使用在很多书刊和杂志上都有介绍,但在日常使用过程中,还有一些问题经常出现,比如说:输入数学公式后行距不等.不能更改公式的颜色.打印时经常出现乱码等.针对上面提到的各种问题,我们来看一下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLdrLp.html" rel="bookmark" class="title">XSLT轻松入门第一章：XSLT概念</a>
					<div>
						概念   提纲         本文共分五大章:XSLT概念,XSLT的实例,XSLT的元素语法,XPath的语法,XSLT的资源.      1.XSLT的概念        1.1 什么是XSLT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boZZBz.html" rel="bookmark" class="title">ASP&period;NET立即上手教程&lpar;9&rpar;</a>
					<div>
						服务器端数据介绍 数据访问是现实世界中应用程序的核心内容.Asp.net提供了一套丰富的控件,他与CLR(通用语言运行库)提供的用来管理数据访问的APIs(应用程序接口)紧密结合.本章预排几个反复使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AVBRp.html" rel="bookmark" class="title">xp忘记密码的另一个解决方法</a>
					<div>
						Windows XP启动脚本(startup scripts)是计算机在登录屏幕出现之前运行的批处理文件,它的功能类似于Windows 9×和DOS中的自动执行批处理文件autoexec.bat. 利 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7Arlb.html" rel="bookmark" class="title">Kali Linux渗透测试实战 1&period;2 环境安装及初始化</a>
					<div>
						在1.1节,我们大致了解了Kali Linux的内置工具集,本节主要介绍虚拟机下的系统安装. 如果您需要定制或者采用其他方式安装系统,请参考官方文档,http://cn.docs.kali.org/. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4dJ8p.html" rel="bookmark" class="title">接口继承的声明问题</a>
					<div>
						某天,小新问我这样一个问题: 类System.Collections.CollectionBase是从IList.ICollection继承而来,IList是从ICollection和IEnumera ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1Yyrz.html" rel="bookmark" class="title">Win 7系统速度慢 或是颜色校正惹祸</a>
					<div>
						如果是Windows7的老用户,从M1到Beta,再从RC到RTM,你都在不断的试用的话,你或许会发现,在使用了Windows7的照片查看器之后,部分用户的系统速度会变慢.特别是当你用Windows照 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDA1Orb.html" rel="bookmark" class="title">C&plus;&plus;设计类不能被继承的方法实例讲解</a>
					<div>
						 在Java 中定义了关键字final,被final修饰的类不能被继承,C++中如何实现,下面我们来看一个例子 首先想到的是在C++中,子类的构造函数会自动调用父类的构造函数.同样,子类的析构函数也会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQQDDp.html" rel="bookmark" class="title">游戏接完支付，登录第三方sdk之后报空指针异常但是找不到错误</a>
					<div>
						问题描述 游戏接完支付,登录第三方sdk之后报空指针异常但是找不到错误 Caused by: java.lang.NullPointerException at com.weedong.gamesdk ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7YAoXM.html" rel="bookmark" class="title">求助正则表达式的问题</a>
					<div>
						问题描述 求助正则表达式的问题 现有一正则表达式 : /^$?[-+]?(?!0+(?:.0+)?$)(?:[1-9]d*|0)(?:.d{1,2})?$/ 此表达式可以匹配 100 , $100 , ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW23Dqb.html" rel="bookmark" class="title">【ARM】Linux驱动移植</a>
					<div>
						1驱动模块移植过程 1模块的第一种编译方法改kconfig 2模块的第二种编译方法Makefile 2Linux驱动原理 0从哪里切入 1什么是注册 2register_chrdev提交哪些数据 21 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQJ0Nz.html" rel="bookmark" class="title">指针-Javascript中通过点操作符定义属性和字面量形式定义的区别</a>
					<div>
						问题描述 Javascript中通过点操作符定义属性和字面量形式定义的区别 我已经有一种这样的困惑:第一种:function Person(){};Person.name = &quot;&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPqGqp.html" rel="bookmark" class="title">SecureCRT中文显示乱码的解决方法</a>
					<div>
						看了网上写的很多文章,他们提到的都差不多,可是我的问题解决还要其他更改.先写一般人出现乱码的解决办法. 1.修改远程linux机器的编码配置 # vi /etc/sysconfig/i18n 进入编码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YlkXM.html" rel="bookmark" class="title">手机app接口开发-手机APP登录接口设计问题，不知道加密方式如何登录？</a>
					<div>
						问题描述 手机APP登录接口设计问题,不知道加密方式如何登录? 不知道网站的密码的加密方式,知道密码,手机APP接口该怎么设计登录呢? 解决方案 用fiddler调试,看看密码是不是明文传过去的.如果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWKYEz.html" rel="bookmark" class="title">linux内核-使用git下载goldfish时出现rpc failed</a>
					<div>
						问题描述 使用git下载goldfish时出现rpc failed 操作系统:ubuntu 12.0.4 git版本:1.9.1 下载使用:git clone https://android.goog ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z403y9z.html" rel="bookmark" class="title">代码-android 分组后各组之间的排序</a>
					<div>
						问题描述 android 分组后各组之间的排序 我做了个貌似通讯录的功能,按照a-z来分组,比如a分组有李先生和lee这两条数据, 插入后是按照先后循序的,但是我现在想英文排在前,文字排在后,要怎么写 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7adQp.html" rel="bookmark" class="title">C&num; 移除字符串末尾指定字符</a>
					<div>
						#region 移除字符串末尾指定字符 /// &lt;summary&gt; /// 移除字符串末尾指定字符 /// &lt;/summary&gt; /// &lt;param name=&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5Y05M.html" rel="bookmark" class="title">一个移动互联网应用地图服务架构</a>
					<div>
						在移动互联网中,各种与位置相关的服务都严重依赖于地图服务,地图服务质量的好坏很大程度决定了所提供服务的高低.尽管有Google Map等免费或收费的地图服务可供使用,但没有那一家地图服务提供商能够完整 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkeYdEb.html" rel="bookmark" class="title">IIS windows服务器，PHP curl显示已激活。</a>
					<div>
						问题描述 IIS windows服务器,PHP curl显示已激活. IIS windows服务器,PHP curl显示已激活.可是为啥我的PHP代码,一旦用到curl就不能够正常的接口调用数据,其中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgYRKM.html" rel="bookmark" class="title">自制mpls&amp;amp&semi;amp&semi;nbsp&semi;ldp实验</a>
					<div>
						实验步骤 步骤1:完成EIGRP BGP 及宣告配置 步骤2:完成LDP 的配置 过程校验 步骤1:校验和理解LDP 邻居关系的发现和邻接关系的建立 R4#show mpls ldp discover ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YRKoz.html" rel="bookmark" class="title">计算机病毒中心：Web论坛程序软件有高危漏洞</a>
					<div>
						新华网天津1月10日专电(记者张建新)国家计算机病毒应急处理中心10日发布消息,称通过对互联网的监测发现,近期Web论坛程序应用软件Discuz!7.2版本存在高危漏洞,提醒用户及时下载安装补丁. 专 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqDnxb.html" rel="bookmark" class="title">WiX Toolset</a>
					<div>
						原文:WiX Toolset 公司换软件打包平台,弄了一个月,Wix toolset的中文资料真的不多,逼着自己看了不少英文资料,终于弄懂了WiX打包的过程,做出了满足要求的安装包 一点基本概念:(F ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyemLZM.html" rel="bookmark" class="title">3种最快提高直通车质量分办法的利弊分析</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 最近经常在很多文章中学习高手们是如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12XY5p.html" rel="bookmark" class="title">如何找到软件接口并调用</a>
					<div>
						问题描述 最近在做项目中遇到一些技术性问题,向大家请教.我们想在自己的平台上嵌入某种仿真语言A,现在想通过研究A所在的国际上通用的软件B找到语言的接口interface,并在我们的平台上嵌入A语言.现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YdLVz.html" rel="bookmark" class="title">trusted-手机上开发miracast ，连接接收端设备时，无法连接 ，错误日志如下： Log：</a>
					<div>
						问题描述 手机上开发miracast ,连接接收端设备时,无法连接 ,错误日志如下: Log: 在手机上开发一个apk,扫描到WifiDisplay的接收设备后,在连接此接收设备时有问题. 系统需要权 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAEBOeM.html" rel="bookmark" class="title">电信运营商员工与调查公司勾结泄露公民信息</a>
					<div>
						本报讯(记者 付中 通讯员 辛祖国)电信运营商工作人员与调查公司勾结,泄露公民个人信息.记者今天获悉,朝阳法院向两公司发出司法建议后,两公司现已回函表示整改. 2010年12月,朝阳法院审结唐纳宇等1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDn8BvM.html" rel="bookmark" class="title">王菲秘密返港为个唱彩排苦练粤语歌为歌迷送惊喜</a>
					<div>
						王菲2011巡回演唱会唱到香港,3月4日将在机场博览馆举行5场演唱会.日前阿菲已经秘密返港进行彩排,积极练唱长达7.8年没唱的粤语歌,香港歌迷有福了.[page] 踏入2011年,王菲巡唱继续展开,首 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlZ4lp.html" rel="bookmark" class="title">六款值得推荐的android（安卓）开源框架简介&lowbar;Android</a>
					<div>
						1.volley 项目地址 https://github.com/smanikandan14/Volley-demo (1)  JSON,图像等的异步下载: (2)  网络请求的排序(scheduli ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1N8Arp.html" rel="bookmark" class="title">利用&percnt;5c绕过验证</a>
					<div>
						利用%5c绕过验证--------------------------------------- lake2(http://mrhupo.126.com) 2004-11-27------------ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvP6WM.html" rel="bookmark" class="title">从是方电讯机房失火看服务商数据中心安全管控</a>
					<div>
						截止26日,受影响的企业多达上百家,其中包括台湾麦当劳.GROUPON.google台湾.Yahoo!奇摩.台湾高铁.华航等超大型企业,台湾麦当劳全台外送专线因此停摆.GROUPON网页停摆用户无法登 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
